// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: switchmodule/switchmodule.proto

package openfmb.switchmodule;

/**
 * <pre>
 * Switch control profile
 * </pre>
 *
 * Protobuf type {@code switchmodule.SwitchDiscreteControlProfile}
 */
public final class SwitchDiscreteControlProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:switchmodule.SwitchDiscreteControlProfile)
    SwitchDiscreteControlProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SwitchDiscreteControlProfile.newBuilder() to construct.
  private SwitchDiscreteControlProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SwitchDiscreteControlProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SwitchDiscreteControlProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.switchmodule.Switchmodule.internal_static_switchmodule_SwitchDiscreteControlProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.switchmodule.Switchmodule.internal_static_switchmodule_SwitchDiscreteControlProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.switchmodule.SwitchDiscreteControlProfile.class, openfmb.switchmodule.SwitchDiscreteControlProfile.Builder.class);
  }

  public static final int CONTROLMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasControlMessageInfo() {
    return controlMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }

  public static final int PROTECTEDSWITCH_FIELD_NUMBER = 2;
  private openfmb.switchmodule.ProtectedSwitch protectedSwitch_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the protectedSwitch field is set.
   */
  @java.lang.Override
  public boolean hasProtectedSwitch() {
    return protectedSwitch_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The protectedSwitch.
   */
  @java.lang.Override
  public openfmb.switchmodule.ProtectedSwitch getProtectedSwitch() {
    return protectedSwitch_ == null ? openfmb.switchmodule.ProtectedSwitch.getDefaultInstance() : protectedSwitch_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.switchmodule.ProtectedSwitchOrBuilder getProtectedSwitchOrBuilder() {
    return protectedSwitch_ == null ? openfmb.switchmodule.ProtectedSwitch.getDefaultInstance() : protectedSwitch_;
  }

  public static final int SWITCHDISCRETECONTROL_FIELD_NUMBER = 3;
  private openfmb.switchmodule.SwitchDiscreteControl switchDiscreteControl_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the switchDiscreteControl field is set.
   */
  @java.lang.Override
  public boolean hasSwitchDiscreteControl() {
    return switchDiscreteControl_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The switchDiscreteControl.
   */
  @java.lang.Override
  public openfmb.switchmodule.SwitchDiscreteControl getSwitchDiscreteControl() {
    return switchDiscreteControl_ == null ? openfmb.switchmodule.SwitchDiscreteControl.getDefaultInstance() : switchDiscreteControl_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.switchmodule.SwitchDiscreteControlOrBuilder getSwitchDiscreteControlOrBuilder() {
    return switchDiscreteControl_ == null ? openfmb.switchmodule.SwitchDiscreteControl.getDefaultInstance() : switchDiscreteControl_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlMessageInfo_ != null) {
      output.writeMessage(1, getControlMessageInfo());
    }
    if (protectedSwitch_ != null) {
      output.writeMessage(2, getProtectedSwitch());
    }
    if (switchDiscreteControl_ != null) {
      output.writeMessage(3, getSwitchDiscreteControl());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlMessageInfo());
    }
    if (protectedSwitch_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getProtectedSwitch());
    }
    if (switchDiscreteControl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSwitchDiscreteControl());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.switchmodule.SwitchDiscreteControlProfile)) {
      return super.equals(obj);
    }
    openfmb.switchmodule.SwitchDiscreteControlProfile other = (openfmb.switchmodule.SwitchDiscreteControlProfile) obj;

    if (hasControlMessageInfo() != other.hasControlMessageInfo()) return false;
    if (hasControlMessageInfo()) {
      if (!getControlMessageInfo()
          .equals(other.getControlMessageInfo())) return false;
    }
    if (hasProtectedSwitch() != other.hasProtectedSwitch()) return false;
    if (hasProtectedSwitch()) {
      if (!getProtectedSwitch()
          .equals(other.getProtectedSwitch())) return false;
    }
    if (hasSwitchDiscreteControl() != other.hasSwitchDiscreteControl()) return false;
    if (hasSwitchDiscreteControl()) {
      if (!getSwitchDiscreteControl()
          .equals(other.getSwitchDiscreteControl())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlMessageInfo()) {
      hash = (37 * hash) + CONTROLMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getControlMessageInfo().hashCode();
    }
    if (hasProtectedSwitch()) {
      hash = (37 * hash) + PROTECTEDSWITCH_FIELD_NUMBER;
      hash = (53 * hash) + getProtectedSwitch().hashCode();
    }
    if (hasSwitchDiscreteControl()) {
      hash = (37 * hash) + SWITCHDISCRETECONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getSwitchDiscreteControl().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.switchmodule.SwitchDiscreteControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.switchmodule.SwitchDiscreteControlProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Switch control profile
   * </pre>
   *
   * Protobuf type {@code switchmodule.SwitchDiscreteControlProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:switchmodule.SwitchDiscreteControlProfile)
      openfmb.switchmodule.SwitchDiscreteControlProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.switchmodule.Switchmodule.internal_static_switchmodule_SwitchDiscreteControlProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.switchmodule.Switchmodule.internal_static_switchmodule_SwitchDiscreteControlProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.switchmodule.SwitchDiscreteControlProfile.class, openfmb.switchmodule.SwitchDiscreteControlProfile.Builder.class);
    }

    // Construct using openfmb.switchmodule.SwitchDiscreteControlProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      protectedSwitch_ = null;
      if (protectedSwitchBuilder_ != null) {
        protectedSwitchBuilder_.dispose();
        protectedSwitchBuilder_ = null;
      }
      switchDiscreteControl_ = null;
      if (switchDiscreteControlBuilder_ != null) {
        switchDiscreteControlBuilder_.dispose();
        switchDiscreteControlBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.switchmodule.Switchmodule.internal_static_switchmodule_SwitchDiscreteControlProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.switchmodule.SwitchDiscreteControlProfile getDefaultInstanceForType() {
      return openfmb.switchmodule.SwitchDiscreteControlProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.switchmodule.SwitchDiscreteControlProfile build() {
      openfmb.switchmodule.SwitchDiscreteControlProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.switchmodule.SwitchDiscreteControlProfile buildPartial() {
      openfmb.switchmodule.SwitchDiscreteControlProfile result = new openfmb.switchmodule.SwitchDiscreteControlProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.switchmodule.SwitchDiscreteControlProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlMessageInfo_ = controlMessageInfoBuilder_ == null
            ? controlMessageInfo_
            : controlMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.protectedSwitch_ = protectedSwitchBuilder_ == null
            ? protectedSwitch_
            : protectedSwitchBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.switchDiscreteControl_ = switchDiscreteControlBuilder_ == null
            ? switchDiscreteControl_
            : switchDiscreteControlBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.switchmodule.SwitchDiscreteControlProfile) {
        return mergeFrom((openfmb.switchmodule.SwitchDiscreteControlProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.switchmodule.SwitchDiscreteControlProfile other) {
      if (other == openfmb.switchmodule.SwitchDiscreteControlProfile.getDefaultInstance()) return this;
      if (other.hasControlMessageInfo()) {
        mergeControlMessageInfo(other.getControlMessageInfo());
      }
      if (other.hasProtectedSwitch()) {
        mergeProtectedSwitch(other.getProtectedSwitch());
      }
      if (other.hasSwitchDiscreteControl()) {
        mergeSwitchDiscreteControl(other.getSwitchDiscreteControl());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getProtectedSwitchFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getSwitchDiscreteControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> controlMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlMessageInfo field is set.
     */
    public boolean hasControlMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlMessageInfo.
     */
    public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
      if (controlMessageInfoBuilder_ == null) {
        return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      } else {
        return controlMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlMessageInfo_ = value;
      } else {
        controlMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(
        openfmb.commonmodule.ControlMessageInfo.Builder builderForValue) {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfo_ = builderForValue.build();
      } else {
        controlMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlMessageInfo_ != null &&
          controlMessageInfo_ != openfmb.commonmodule.ControlMessageInfo.getDefaultInstance()) {
          getControlMessageInfoBuilder().mergeFrom(value);
        } else {
          controlMessageInfo_ = value;
        }
      } else {
        controlMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfo.Builder getControlMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
      if (controlMessageInfoBuilder_ != null) {
        return controlMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return controlMessageInfo_ == null ?
            openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> 
        getControlMessageInfoFieldBuilder() {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder>(
                getControlMessageInfo(),
                getParentForChildren(),
                isClean());
        controlMessageInfo_ = null;
      }
      return controlMessageInfoBuilder_;
    }

    private openfmb.switchmodule.ProtectedSwitch protectedSwitch_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.switchmodule.ProtectedSwitch, openfmb.switchmodule.ProtectedSwitch.Builder, openfmb.switchmodule.ProtectedSwitchOrBuilder> protectedSwitchBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the protectedSwitch field is set.
     */
    public boolean hasProtectedSwitch() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The protectedSwitch.
     */
    public openfmb.switchmodule.ProtectedSwitch getProtectedSwitch() {
      if (protectedSwitchBuilder_ == null) {
        return protectedSwitch_ == null ? openfmb.switchmodule.ProtectedSwitch.getDefaultInstance() : protectedSwitch_;
      } else {
        return protectedSwitchBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setProtectedSwitch(openfmb.switchmodule.ProtectedSwitch value) {
      if (protectedSwitchBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        protectedSwitch_ = value;
      } else {
        protectedSwitchBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setProtectedSwitch(
        openfmb.switchmodule.ProtectedSwitch.Builder builderForValue) {
      if (protectedSwitchBuilder_ == null) {
        protectedSwitch_ = builderForValue.build();
      } else {
        protectedSwitchBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeProtectedSwitch(openfmb.switchmodule.ProtectedSwitch value) {
      if (protectedSwitchBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          protectedSwitch_ != null &&
          protectedSwitch_ != openfmb.switchmodule.ProtectedSwitch.getDefaultInstance()) {
          getProtectedSwitchBuilder().mergeFrom(value);
        } else {
          protectedSwitch_ = value;
        }
      } else {
        protectedSwitchBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearProtectedSwitch() {
      bitField0_ = (bitField0_ & ~0x00000002);
      protectedSwitch_ = null;
      if (protectedSwitchBuilder_ != null) {
        protectedSwitchBuilder_.dispose();
        protectedSwitchBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.switchmodule.ProtectedSwitch.Builder getProtectedSwitchBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getProtectedSwitchFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.switchmodule.ProtectedSwitchOrBuilder getProtectedSwitchOrBuilder() {
      if (protectedSwitchBuilder_ != null) {
        return protectedSwitchBuilder_.getMessageOrBuilder();
      } else {
        return protectedSwitch_ == null ?
            openfmb.switchmodule.ProtectedSwitch.getDefaultInstance() : protectedSwitch_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.ProtectedSwitch protectedSwitch = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.switchmodule.ProtectedSwitch, openfmb.switchmodule.ProtectedSwitch.Builder, openfmb.switchmodule.ProtectedSwitchOrBuilder> 
        getProtectedSwitchFieldBuilder() {
      if (protectedSwitchBuilder_ == null) {
        protectedSwitchBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.switchmodule.ProtectedSwitch, openfmb.switchmodule.ProtectedSwitch.Builder, openfmb.switchmodule.ProtectedSwitchOrBuilder>(
                getProtectedSwitch(),
                getParentForChildren(),
                isClean());
        protectedSwitch_ = null;
      }
      return protectedSwitchBuilder_;
    }

    private openfmb.switchmodule.SwitchDiscreteControl switchDiscreteControl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.switchmodule.SwitchDiscreteControl, openfmb.switchmodule.SwitchDiscreteControl.Builder, openfmb.switchmodule.SwitchDiscreteControlOrBuilder> switchDiscreteControlBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the switchDiscreteControl field is set.
     */
    public boolean hasSwitchDiscreteControl() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The switchDiscreteControl.
     */
    public openfmb.switchmodule.SwitchDiscreteControl getSwitchDiscreteControl() {
      if (switchDiscreteControlBuilder_ == null) {
        return switchDiscreteControl_ == null ? openfmb.switchmodule.SwitchDiscreteControl.getDefaultInstance() : switchDiscreteControl_;
      } else {
        return switchDiscreteControlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSwitchDiscreteControl(openfmb.switchmodule.SwitchDiscreteControl value) {
      if (switchDiscreteControlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        switchDiscreteControl_ = value;
      } else {
        switchDiscreteControlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSwitchDiscreteControl(
        openfmb.switchmodule.SwitchDiscreteControl.Builder builderForValue) {
      if (switchDiscreteControlBuilder_ == null) {
        switchDiscreteControl_ = builderForValue.build();
      } else {
        switchDiscreteControlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeSwitchDiscreteControl(openfmb.switchmodule.SwitchDiscreteControl value) {
      if (switchDiscreteControlBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          switchDiscreteControl_ != null &&
          switchDiscreteControl_ != openfmb.switchmodule.SwitchDiscreteControl.getDefaultInstance()) {
          getSwitchDiscreteControlBuilder().mergeFrom(value);
        } else {
          switchDiscreteControl_ = value;
        }
      } else {
        switchDiscreteControlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearSwitchDiscreteControl() {
      bitField0_ = (bitField0_ & ~0x00000004);
      switchDiscreteControl_ = null;
      if (switchDiscreteControlBuilder_ != null) {
        switchDiscreteControlBuilder_.dispose();
        switchDiscreteControlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.switchmodule.SwitchDiscreteControl.Builder getSwitchDiscreteControlBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getSwitchDiscreteControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.switchmodule.SwitchDiscreteControlOrBuilder getSwitchDiscreteControlOrBuilder() {
      if (switchDiscreteControlBuilder_ != null) {
        return switchDiscreteControlBuilder_.getMessageOrBuilder();
      } else {
        return switchDiscreteControl_ == null ?
            openfmb.switchmodule.SwitchDiscreteControl.getDefaultInstance() : switchDiscreteControl_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.switchmodule.SwitchDiscreteControl switchDiscreteControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.switchmodule.SwitchDiscreteControl, openfmb.switchmodule.SwitchDiscreteControl.Builder, openfmb.switchmodule.SwitchDiscreteControlOrBuilder> 
        getSwitchDiscreteControlFieldBuilder() {
      if (switchDiscreteControlBuilder_ == null) {
        switchDiscreteControlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.switchmodule.SwitchDiscreteControl, openfmb.switchmodule.SwitchDiscreteControl.Builder, openfmb.switchmodule.SwitchDiscreteControlOrBuilder>(
                getSwitchDiscreteControl(),
                getParentForChildren(),
                isClean());
        switchDiscreteControl_ = null;
      }
      return switchDiscreteControlBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:switchmodule.SwitchDiscreteControlProfile)
  }

  // @@protoc_insertion_point(class_scope:switchmodule.SwitchDiscreteControlProfile)
  private static final openfmb.switchmodule.SwitchDiscreteControlProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.switchmodule.SwitchDiscreteControlProfile();
  }

  public static openfmb.switchmodule.SwitchDiscreteControlProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SwitchDiscreteControlProfile>
      PARSER = new com.google.protobuf.AbstractParser<SwitchDiscreteControlProfile>() {
    @java.lang.Override
    public SwitchDiscreteControlProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SwitchDiscreteControlProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SwitchDiscreteControlProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.switchmodule.SwitchDiscreteControlProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

